/*
 * Copyright (c) 2005-2011 KOM - Multimedia Communications Lab
 *
 * This file is part of PeerfactSim.KOM.
 * 
 * PeerfactSim.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */



package de.tud.kom.p2psim.api.scenario;

import de.tudarmstadt.maki.simonstrator.api.component.GlobalComponent;

/**
 * Right way to create a scenario is to use a factory extending this interface.
 * 
 * @author Sebastian Kaune
 * @author Konstantin Pussep
 * @version 3.0, 03.12.2007
 * 
 * @see Scenario
 */
public interface ScenarioFactory extends GlobalComponent {
	/**
	 * Create the scenario by using the data provided via the
	 * <code>Configurator</code>.
	 * 
	 * @return scenario generated by this factory
	 */
	public Scenario createScenario();
}
