/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 *
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tud.kom.p2psim.impl.vehicular.caching.invalidation;

import de.tudarmstadt.maki.simonstrator.api.component.vehicular.caching.invalidation.CacheInvalidationStrategy;

public enum CacheInvalidationStrategyType {
	DEFAULT(DefaultCacheInvalidationStrategy.class), NONE(DefaultCacheInvalidationStrategy.class), TTL(TTLBasedCacheInvalidationStrategy.class);

	private final Class<? extends CacheInvalidationStrategy> replacementStrategy;

	private CacheInvalidationStrategyType(final Class<? extends CacheInvalidationStrategy> replacementStrategy) {
		this.replacementStrategy = replacementStrategy;
	}

	public CacheInvalidationStrategy getInvalidationStrategy() {
		try {
			return replacementStrategy.newInstance();
		} catch (InstantiationException | IllegalAccessException e) {
			throw new AssertionError(e);
		}
	}
}
